/*
 * thread_ex2.cpp
 *
 *  Created on: May 1, 2011
 *      Author: lipari
 */

#include <boost/thread.hpp>
#include <iostream>
#include "thread_ex2.hpp"
#include "example_map.hpp"

using namespace std;

namespace example_thread2
{
	oosd::register_in_map __reg("thread_example2", main);

	int x = 0;
	void myexit()
	{
		cout << "Ehi, I'm exiting!" << endl;
		x = 1;
	}

	void long_thread()
	{
		boost::this_thread::at_thread_exit(myexit);
		cout << "Long thread started" << endl;
		for (long long i=0; i<100000000; i++);
	}

	void make_thread()
	{
		boost::thread th(long_thread);
	}

	int main()
	{
		cout << "Launching the thread" << endl;
		make_thread();
		cout << "The thread is now detached" << endl;
		while (!x);
		cout << "End!" << endl;
	}
}
